include "bios.inc"
include "subbin.inc"
include "VVram.inc"
include "share.inc"

ext  @Temp@Word

PatternRam equ $8000
SharedRam equ $FC80
Bank equ $fd0f

Vram equ $0000

VramWidth equ 80
VramHeight equ 25
CharHeight equ 8
VramRowSize equ VramWidth*CharHeight
VramTop equ Vram+VramRowSize

PatternSize equ CharHeight*3*2

ext VVram_
ext SendSubsys, HaltSubsys, ResuumeSubsys, WaitSubsys, WriteSharedRam

dseg
Backup:
    defs VVramWidth*VVramHeight
zseg
MakePatternMono_planeCount:
    defb 0    
MakePatternMono_yCount:
    defb 0
MakePatternMono_byteCount:
    defb 0
MakePatternMono_bitCount:
    defb 0
MakePatternMono_charColor:
    defb 0
VVramToVram_yCount:
    defb 0
VVramToVram_xCount:
    defb 0
VVramToVram_vram:
    defw 0
VVramToVram_pFlags:
    defw 0
VVramToVram_flags:
    defb 0
VVramToVram_mask:
    defb 0
invertedByte:
    defb 0
MakePatternColor_yCount:
    defb 0
MakePatternColor_byteCount:
    defb 0
MakePatternColor_bitCount:
    defb 0


; void MakePatternMono(byte c, ptr<byte> pSource, byte count, byte color);
dseg
MakePatternMono_@Param2: public MakePatternMono_@Param2
MakePatternMono_count:
    defb 0
MakePatternMono_@Param3: public MakePatternMono_@Param3
MakePatternMono_color:
    defb 0
cseg
MakePatternMono_: public MakePatternMono_
    pshs a,b,x,y
        orcc #$50
        sta Bank

        ldb #PatternSize
        mul
        addd #PatternRam
        tfr d,x

        do
            lda MakePatternMono_color
            sta MakePatternMono_charColor

            lda #3
            sta <MakePatternMono_planeCount
            do
                pshs y
                    lda #CharHeight
                    sta <MakePatternMono_yCount
                    do
                        clrb
                        lda MakePatternMono_charColor
                        bita #$01
                        if ne
                            orb ,y
                        endif
                        bita #$10
                        if ne
                            lda ,y
                            coma
                            sta <invertedByte
                            orb <invertedByte
                        endif
                        lda #2
                        sta <MakePatternMono_byteCount
                        do
                            lda #4
                            sta <MakePatternMono_bitCount
                            clra
                            do
                                lsla
                                lsla
                                lslb
                                if cs
                                    ora #$03
                                endif
                                dec <MakePatternMono_bitCount
                            while ne | wend
                            sta ,x+
                            dec <MakePatternMono_byteCount
                        while ne | wend
                        leay 1,y
                        dec <MakePatternMono_yCount
                    while ne | wend
                puls y
                lsr <MakePatternMono_charColor
                dec <MakePatternMono_planeCount
            while ne | wend
            leay CharHeight,y
            dec MakePatternMono_count
        while ne | wend
        lda Bank
        andcc #not $50
    puls a,b,x,y
rts


; void MakePatternColor(byte c, ptr<byte> pSource, byte count);
dseg
MakePatternColor_@Param2: public MakePatternColor_@Param2
MakePatternColor_count:
    defb 0
cseg
MakePatternColor_: public MakePatternColor_
    pshs a,b,x,y
        orcc #$50
        sta Bank

        ldb #PatternSize
        mul
        addd #PatternRam
        tfr d,x
        do
            lda #PatternSize
            sta <MakePatternMono_yCount
            do
                ldb ,y+
                lda #2
                sta <MakePatternMono_byteCount
                do
                    lda #4
                    sta <MakePatternMono_bitCount
                    clra
                    do
                        lsla
                        lsla
                        lslb
                        if cs
                            ora #$03
                        endif
                        dec <MakePatternMono_bitCount
                    while ne | wend
                    sta ,x+
                    dec <MakePatternMono_byteCount
                while ne | wend
                dec <MakePatternMono_yCount
            while ne | wend
            dec MakePatternColor_count
        while ne | wend
        lda Bank
        andcc #not $50
    puls a,b,x,y
rts


; void StartSubMain();
cseg
SubMain_Command:
    defb 0,0
    defb SUB.TEST
    defb 'YAMAUCHI'
    defb $93
    defw SubMain
    defb $90
StartSubMain_: public StartSubMain_
    pshs x,b,a
        ldx #SubMain_Command
        ldb #StartSubMain_-SubMain_Command
        jsr SendSubsys
    puls x,b,a
rts


Halt:
    pshs a
        HaltLoop:
        do
            lda $FD05
        while mi | wend
        orcc #$50
        lda #$80
        sta $FD05
        tst SharedRam
        if ne
            clr $FD05
            andcc #not $50
            bra HaltLoop
        endif
    puls a
rts

Resume:
    clr $FD05
    andcc #not $50
rts

; void ClearScreen();
cseg
ClearScreen_:   public ClearScreen_
    pshs x,b,a
        jsr Halt
        lda #SubCommand_Clear
        sta SharedRam+Share_Command
        jsr Resume
        clr lastChar

        ldx #Backup
        ldd #VVramWidth*VVramHeight
        do
            clr ,x+
            subd #1
        while ne | wend
    puls x,b,a
rts


; word Put(word vram, byte c);
dseg
    lastChar: defb 0
cseg
Put_: public Put_
    pshs a,b,x,y
        jsr Halt
        lda #SubCommand_PutP | sta SharedRam+Share_Command
        stx SharedRam+Share_Address
        cmpb lastChar
        if ne
            stb lastChar
            pshs cc | orcc #$50
                lda #PatternSize
                mul
                addd #PatternRam
                tfr d,x
                pshs cc | orcc #$50
                    sta Bank
                        ldy #SharedRam+Share_Pattern
                        ldb #PatternSize
                        do
                            lda ,x+
                            sta ,y+
                            decb
                        while ne | wend
                    lda Bank
                puls cc
            puls cc
        endif
        jsr Resume
    puls a,b,x,y
    tfr x,d
    addd #2
rts


; void VVramToVram();
VVramToVram_: public VVramToVram_
    pshs a,b,x,y
        ldx #VramTop
        stx <VVramToVram_vram
        ldx #VVram_
        ldy #Backup
        lda #VVramHeight
        sta <VVramToVram_yCount
        do
            lda #VVramWidth
            sta <VVramToVram_xCount
            do 
                ldb ,x+
                cmpb ,y
                if ne
                    stb ,y
                    pshs x
                        ldx <VVramToVram_vram
                        bsr Put_
                    puls x
                endif
                leay 1,y
                pshs x
                    ldx <VVramToVram_vram
                    leax 2,x
                    stx <VVramToVram_vram
                puls x
                dec <VVramToVram_xCount
            while ne | wend
            pshs x
                ldx <VVramToVram_vram
                leax VramRowSize-VVramWidth*2,x
                stx <VVramToVram_vram
            puls x
            dec <VVramToVram_yCount
        while ne | wend
    puls a,b,x,y
rts


